var sips2webview = undefined;

// mis a 'true' uniquement quand c'est suite à la détection d'un changement d'url dans la webview qu'on ferme la vue. Sinon c'est l'utilisateur qui a choisi de fermer la vue.
var requestClose = false;

$('#paiementsips2').live('pageshow',function(event)
{
    setActiveMenu();
		
	//affectation du lien retour en fonction de la provenance
	if(amendeConsignable) {
		$('#paiementsips2BackButton').attr('href','#choixpaiement');
		$('#paiementsips2BButtonEtr').attr('href','#choixpaiement');
	}
	else {
		$('#paiementsips2BackButton').attr('href','#saisienumero');
		$('#paiementsips2ButtonEtr').attr('href','#saisienumero');
	}
	
	//modification du titre en fonction du mode de r�glement
	if(mode=='paiement')
	{
        $(this).find('.ui-title').text($.i18n.prop('saisiecb.titre_payer'));
        $(this).find('#paiementsips2-submit-bouton').text($.i18n.prop('paiementsips2.bouton_valider'));
	}
	else
	{
        $(this).find('.ui-title').text($.i18n.prop('saisiecb.titre_consigner'));
        $(this).find('#paiementsips2-submit-bouton').text($.i18n.prop('paiementsips2.bouton_consigner'));
    }
    
    $('#paiementsips2-submit-bouton').removeClass('ui-disabled');

});

$('#paiementsips2-submit-bouton').live('click',function()
{
    $('#paiementsips2-submit-bouton').addClass('ui-disabled');
	overlay.show();
	
    $.post(host+'/DemanderPaiementSIPS2','DemanderPaiementSIPS2RequestBean={version:"'+myVersion+'",langue:"'+currentLanguage+'",navigateur:"'+myNavigateur+'",hashcode:"'+token+'"}').done(function(data)
		{
			overlay.hide();
            var myResult = $.parseJSON(data);
			traiterRetourErreur(myResult);
			if (myResult.codeRetour == 0)
			{
                var redirectionURL = myResult.redirectionUrl;
                openWebView(redirectionURL);
			}
		});
});

function openWebView(url) {
    url = '<html><body>' + url + '<script type="text/javascript">document.getElementsByName("redirectionSips")[0].submit();</script></body></html>';
    url = 'data:text/html;base64,' + btoa(url);
    // sips2webview = cordova.InAppBrowser.open(url, '_blank', 'location=yes,hideurlbar=yes,hidenavigationbuttons=no,hidden=yes');
    sips2webview = cordova.InAppBrowser.open(url, '_blank', 'location=no,hidden=yes');
    requestClose = false;
	sips2webview.addEventListener('loadstop', onWebViewLoadStop);
	sips2webview.addEventListener('loadstart', onWebViewLoadStart);
	sips2webview.addEventListener('loaderror', onWebViewLoadError);
	sips2webview.addEventListener('exit', onWebViewExit);
}

function onWebViewLoadStop(event) {
    console.log("onWebViewLoadStop, url:" + event.url);
    sips2webview.insertCSS({code : "a[role=button].k-print {display: none;}"});
    //sips2webview.executeScript({code: "(function() { console.log(\"XXXXXExecuting loadStop window script\");var closeButton=document.getElementById(\"cancel_0\");console.log(\"close button is \" + closeButton ); })()"});
	overlay.hide();
	sips2webview.show();
}

function onWebViewLoadStart(event) {
	console.log("onWebViewLoadStart, url:" + event.url);
	if (!testCloseWebView(event)) {
        overlay.show();
	}
}

function testCloseWebView(event) {
    let regexpConfirm=/.*\/tai\/paiement\/confirmation.*/;
    let regexpErreur=/.*\/tai\/erreur\/(\d+).*/;

    if (regexpConfirm.test(event.url)) {
        console.log("Page de paiement SIPS2: retour au site commercant apres transaction reussie.");
        closeSips2Webview();
        afficherPageJustif();
        return true;
    }

    if (regexpErreur.test(event.url)) {
        let codeErreurSips2 = regexpErreur.exec(event.url)[1];
        console.log("Page de paiement SIPS2: retour au site commercant avec code erreur:" + codeErreurSips2);
        closeSips2Webview();
        console.log("Retour en page d'accueil");
        $.mobile.changePage($('#home'));
        console.log("Affichage du message'" + $.i18n.prop('sips2.erreur' + codeErreurSips2) + "'");
        afficherMessage($.i18n.prop('sips2.erreur' + codeErreurSips2));
        return true;
    }

	return false;
}

function closeSips2Webview() {
    overlay.hide();
    requestClose = true;
    sips2webview.close();
}

function afficherPageJustif() {
    submitDemanderAmendeReglable(numeroTelepaiement.replace(/-/g,''), calculCle(numeroTelepaiement), function(data) {
        overlay.hide();
        console.log(data);

        var myResult = $.parseJSON(data);
        traiterRetourErreur(myResult);

        if(myResult.codeRetour == 2)
        {
            amende_paye=true;
            //construction de l'objet de justificatif
            infosPourJustificatif =
                {
                    numeroTelepaiement:format_numero_telepaiement_with_hyphen(myResult.justificatif.numeroTelepaiement),
                    montant:myResult.justificatif.montant,
                    dateReglement:myResult.justificatif.dateReglement,
                    numeroCarteBancaire:myResult.justificatif.numeroCarteBancaire,
                    numeroAutorisation:myResult.justificatif.numeroAutorisation,
                    referenceReglement:myResult.justificatif.referenceReglement,
                    media:myResult.justificatif.media,
                    nouveauJustificatif:true
                }
            $.mobile.changePage($('#justificatif'));
        }
        else {
            // SIPS2 nous a notifié une transaction réussie mais l'amende n'est pas au statut 'payée': il y a un souci.
            afficherMessage($.i18n.prop('sips2.erreur.default'));
            $.mobile.changePage($('#home'));
        }

    });
}

function onWebViewLoadError() {
	console.log("onWebViewLoadError");
	overlay.hide();
	sips2webview.close();
	//TODO Ajouter un message specifique quand le site TAI est injoignable
	afficherMessage($.i18n.prop('home.erreurAjax'));
	$.mobile.changePage($('#home'));
}

function onWebViewExit() {
    console.log("onWebViewExit, requested by user :" + (!requestClose));
    if (!requestClose) {
        // Fermeture de la vue demandee par l'utilisateur, on revient en page d'accueil.
        $.mobile.changePage($('#home'));
    }
}